<?php

namespace App\Classes\Modules\Companies\DataTransferObjects;

use App\Classes\General\Interfaces\DataTransferObject;
use App\Classes\ValueObjects\Constants\ApprovalStatus;
use App\Classes\ValueObjects\Constants\BusinessType;

class CompanyObject implements DataTransferObject
{
    /** @var string */
    private $name;

    /** @var string */
    private $reference;

    /** @var int|null */
    private $type;

    /** @var int|null */
    private $status;

    /** @var string */
    private $unity_hash_id;

    /**
     * CompanyObject constructor.
     * @param string $name
     * @param string $reference
     * @param int|null $type
     * @param int|null $status
     */
    public function __construct(
        string $name,
        string $reference,
        ?int $type = BusinessType::IMPORTER,
        ?int $status = ApprovalStatus::PENDING_SUBMISSION
    ) {
        $this->name = $name;
        $this->reference = $reference;
        $this->type = $type;
        $this->status = $status;
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @return string
     */
    public function getReference(): string
    {
        return $this->reference;
    }

    /**
     * @return int
     */
    public function getType(): int
    {
        return $this->type;
    }

    /**
     * @return int
     */
    public function getStatus(): int
    {
        return $this->status;
    }

}
